=== debian/changelog ===
love (11.5-2build1) resolute; urgency=medium

  * Rebuild against latest libtheora

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 02 Nov 2025 11:19:34 -0500

love (11.5-2) unstable; urgency=medium

  * Revert "switch to libluajit2-5.1-dev" (Closes: #1072351)
  * Enablue build on loong64 (Closes: #1059142)

 -- Alexandre Detiste <tchet@debian.org>  Sat, 01 Jun 2024 20:23:59 +0200

love (11.5-1) unstable; urgency=medium

  * New upstream version 11.5
  * add myself as uploader
  * add debian/gbp.conf
  * debian/watch: Use GitHub /tags rather than /releases page.
  * update build dependencies:
    * libfreetype6-dev -> libfreetype-dev
    * libluajit-5.1-dev -> libluajit2-5.1-dev
    * pkg-config -> pkgconf

  [ Janitor ]
  * Remove obsolete field Name from debian/upstream/metadata (already present in
    machine-readable debian/copyright).

 -- Alexandre Detiste <tchet@debian.org>  Sun, 11 Feb 2024 14:10:15 +0100
