=== debian/watch ===
version=4
https://github.com/love2d/love/tags .*/@ANY_VERSION@@ARCHIVE_EXT@
